
//*******************************************************************************************
//Modalit A		Schermata principale
//*******************************************************************************************

void modA ()
{	unsigned char temperatureLCD [2]; //stringa che contiene il valore della temperatura
	unsigned char batteryLevelLCD[3];
	unsigned char powerConnected =0;
	
	AlarmFlag = 0;
	timeAlarm = 0;
	ServoDirection = 0;	//disabilito il rinfresco dei servi
	PORTE = 0;			//Spengo i LED
	Halt ();
			
	ClearLCD ();	
	
	while (1)
	{	if (modality != MODA)
			break;
		
		HomeLCD ();
		
		//scrivo l'ora sull'LCD	
		
		WriteVarLCD (Time);			// scrivo la variabile che contiene l'ora sull'LCD	
		WriteStringLCD ("     ");	//inserisco uno spazio


		//scrivo la temperatura sull'LCD

		itoa (temperature,temperatureLCD);
	
		if (!isdigit(temperatureLCD[1]))	
			{
				temperatureLCD[1]= temperatureLCD[0];
				temperatureLCD[0]=' ';
			}
		WriteStringLCD ("T: " );
		WriteCharLCD (temperatureLCD[0]); // scrivo l'intensit sul display
		WriteCharLCD (temperatureLCD[1]);
		WriteStringLCD ("C" );	

		//scrivo la data sull'LCD
	
		Line2LCD ();
		WriteVarLCD (Date);		//visualizzo la data di sistema
		WriteStringLCD ("    ");
		
		//Scrivo il livello della batteria sull'LCD
		
		if (batteryLevel > 122)	//controllo che la percentuale non sia maggiore di 100
		{			
			batteryLevelLCD[0]='P';			
			batteryLevelLCD[1]='O';
			batteryLevelLCD[2]='W';	
			
			if (powerConnected == 0)	// Il caricabatterie  stato appena connesso
			{	
				beep ();
				Delay (5);
				beep ();
				powerConnected = 1;
			}	
		}
		
		else
		
		if (batteryLevel > 100)	//controllo che la percentuale non sia maggiore di 100
		{			
			batteryLevelLCD[0]='1';			
			batteryLevelLCD[1]='0';
			batteryLevelLCD[2]='0';	
			powerConnected = 0;		//caricabatterie staccato	
		}
		
		else
		
		{ itoa (batteryLevel,batteryLevelLCD);// converto la temperatura in stringa
		  powerConnected = 0;		//caricabatterie staccato
	
		  if (!isdigit(batteryLevelLCD[1]))	
			{
				batteryLevelLCD[2]=batteryLevelLCD[0];
				batteryLevelLCD[1]=' ';
				batteryLevelLCD[0]=' ';	
			}
		
			if (!isdigit(batteryLevelLCD[2]))
			{	
				batteryLevelLCD[2]=batteryLevelLCD[1];
				batteryLevelLCD[1]= batteryLevelLCD[0];
				batteryLevelLCD[0]=' ';						
			}
		}		
		
				
		WriteCharLCD (batteryLevelLCD[0]); // scrivo l'intensit sul display
		WriteCharLCD (batteryLevelLCD[1]); // scrivo l'intensit sul display
		WriteCharLCD (batteryLevelLCD[2]); // scrivo l'intensit sul display
		
		if (batteryLevelLCD[0] != 'P')	//Se non scrivo POW scrivo il carattere %
			WriteCharLCD ('%');		
		else
			WriteCharLCD (' '); //cancello il carattere di percentuale	
			
		
		
		if (timeAlarm == 1)	// controllo se attivare la sveglia
			{	beep ();
				Delay (2);	
			}
	}
}


//*******************************************************************************************
//Modalit B		Explorer
//*******************************************************************************************

void modB ()
{	unsigned char once = 0;	//permette di passare sempre per la posizione centrale
	unsigned char oldDistanceLeft =0;	//distanza a sinistra precedente
	unsigned char oldDistanceRight =0;	//distanza a destra precedente
	unsigned char oldDistance =0;		//distanza a frontale precedente
	unsigned char startTime[6];	//stringa con l' orario d' attivazione della modalit
	int delta; 	//variabile che contiene il delta tra orario attivazione e ora corrente
	unsigned char remainLCD [3];	//tempo rimanente da visualizzare

	
	AlarmFlag = 0;		//resetto alcune variabili 
	timeAlarm = 0;
	ServoDirection = 0;	//disabilito il rinfresco dei servi
	LeftCrash =0;
	RightCrash =0;
	LeftRoadBlock = 0;
	RightRoadBlock = 0;
	FrontRoadBlock = 0;
	leftCounter = 0;
	rightCounter = 0;
	frontCounter = 0;	
	PORTE = 0;			//Spengo i LED
	Halt ();
		
	
	ClearLCD ();
	WriteStringLCD ("    Explorer");
	Line2LCD ();
	WriteStringLCD ("     -- min");
	
	ShiftCursorLCD (LEFT);	// riposiziono il cursore per riscrivere il tempo
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	
	
	ServoDirection = 2;	// posiziono il servo al centro
	
	Delay (20);
	if (modality != MODB)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODB)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODB)
			return;
	beep ();	
	Delay (20);
	if (modality != MODB)
			return;
	
	copyStr (startTime,ReadTime());	//memorizzo l'orario di attivazione della modalit
	
	while (Echo);
	
	while (1)
	{
		if (modality != MODB)
			break;
			
				
			if (Echo == 1)
			{					
				total_us = 0;
				
				while (Echo == 1)
				{	
					total_us++;
					
					_asm
					nop			//il nop rallenta il ciclo di lettura tarando correttamente la lettura
					_endasm					
					
				}	
			
			//Misura a Sinistra	
			
			if (ServoDirection == 1)	
			{
				distanceLeft = total_us >>5;	//divisione per 32
				
				if ((distanceLeft - oldDistanceLeft) < DELTA_BLOCK)
					{
						leftCounter++;
												
						if (leftCounter>NUM_BLOCK) 
							LeftRoadBlock = 1;								
					}
				else
					{
						leftCounter = 0;
						LeftRoadBlock = 0;
					}
					
				oldDistanceLeft = distanceLeft; 
			}
			
			//Misura Frontale
			
			if (ServoDirection == 2)	
			{
				distance = total_us >>5;	//divisione per 32
				
				if ((distance - oldDistance) < DELTA_BLOCK)
					{	
						frontCounter++;
						
						if (frontCounter>NUM_BLOCK) 
							FrontRoadBlock = 1;								
					}
				else
					{
						frontCounter = 0;
						FrontRoadBlock = 0;
					}
				
				oldDistance = distance;
			}
			
			// Misura a Destra
				
			if (ServoDirection == 3)	
			{
				distanceRight = total_us >>5;	//divisione per 32
				
				if ((distanceRight - oldDistanceRight) < DELTA_BLOCK)
					{
						rightCounter++;
							
						if (rightCounter>NUM_BLOCK) 
							LeftRoadBlock = 1;								
					}
				else
					{
						rightCounter = 0;
						LeftRoadBlock = 0;
					}
				
				oldDistanceRight = distanceRight;
			}
				
				
				if (once == 0)
					ServoDirection++;
				else
					{
						ServoDirection--;
						once =0;
					}					
						
				if (ServoDirection > 3 && once ==0)
				{					
					ServoDirection = 2;	
					once = 1;
				}
							
			Delay (3);				
			
			motionControl ();
			
			
			//controllo che sia passato il tempo di pulizia
			
			delta = deltaTime (startTime,ReadTime());
			
			if (delta == ReadEEprom (0xA0,0x00,0x76) || delta <0 ) //prelevo il tempo di pulizia dalla EEPROM
				{
					beep ();
					delay (20);
					beep ();
					delay (20);
					
					modality = MODA;	//essendo passato il tempo inserisco la modalit MODA
				}
			
		  
		  itoa ((ReadEEprom (0xA0,0x00,0x76)-delta),remainLCD);// converto la temperatura in stringa
	
		  if (!isdigit(remainLCD[1]))	
			{
				remainLCD[2]=remainLCD[0];
				remainLCD[1]=' ';
				remainLCD[0]=' ';	
			}
		
			if (!isdigit(remainLCD[2]))
			{	
				remainLCD[2]=remainLCD[1];
				remainLCD[1]= remainLCD[0];
				remainLCD[0]=' ';						
			}
							
			WriteCharLCD (remainLCD[0]);	//scrivo il tempo sul display
			WriteCharLCD (remainLCD[1]);
			WriteCharLCD (remainLCD[2]);
			
			ShiftCursorLCD (LEFT);	// riposiziono il cursore per riscrivere il tempo
			ShiftCursorLCD (LEFT);
			ShiftCursorLCD (LEFT);			
			
			//controllo se il livello della batteria  accettabile per il movimento
			
			if (batteryLevel < 20)
				modality = MODA;	//con un livelo basso inserisco la modalit MODA
							
			while (Echo);
			
			}	
	}	 				
}

//*******************************************************************************************
//Modalit C		Alarm 
//*******************************************************************************************

void modC ()
{	int diff;
	unsigned char firstTime;
	int oldDistance = 0;			//distanza precedente
	unsigned char distanceLCD [3]; //la distanza e' una stringa visualizzabile su LCD

	
  	AlarmFlag = 0;
  	timeAlarm = 0;
  	ServoDirection = 0;	//disabilito il rinfresco dei servi
  	PORTE = 0;			//Spengo i LED
  	Halt ();
  			
	ClearLCD ();
	
	WriteStringLCD ("     Alarm!");
	Line2LCD ();		
	WriteStringLCD ("Distance: --- cm");
		
	
//sposto il cursore all'inizio della cifra piu' significativa della misura	
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);	


	Delay (20);
	if (modality != MODC)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODC)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODC)
			return;
	beep ();	
	Delay (20);
	if (modality != MODC)
			return;
			
	firstTime = 0;		
    	
	while (1)
	{			
		if (modality != MODC)
			break;
	
		if (Echo == 1)
			{					
				total_us = 0;
				
				while (Echo == 1)
				{	
					total_us++;
					
					_asm
					nop			//il nop rallenta il ciclo di lettura tarando correttamente la lettura
					_endasm
										
				}	
				
				distance = total_us >>5;	//divisione per 32
				
				if (distance>MAX_DISTANCE)
					distance = MAX_DISTANCE + 1;
					
				if (!firstTime)
					{
						oldDistance = distance;
						firstTime = 1;
					}
					
		diff = oldDistance-distance;	// controllo se qualcuno si avvicina		
		
		if ( diff > DELTA_DISTANCE)
			AlarmFlag = 1;
			
		diff = distance-oldDistance;	// controllo se qualcuno si allontana		
		
		if ( diff > DELTA_DISTANCE)
			AlarmFlag = 1;
		
		
		if (AlarmFlag)	
		{	
			PORTE = 0b00000011;			
			Delay (2);
			PORTE = 0b00000001;	
			Delay (2);						
		}
		

// oltre i 4 metri la misura perde di significato e viene visualizzato <->
				
				if (distance> MAX_DISTANCE)	
					{	
						distanceLCD[2]='>';
						distanceLCD[1]='-';
						distanceLCD[0]='<';						
					}
				else 
					{
						itoa (distance,distanceLCD);	// converto la distanza in una stringa	

//sposto le cifre in modo da mantenere lo stesso valore posizionale				
						if (!isdigit(distanceLCD[1]))	
							{
								distanceLCD[2]=distanceLCD[0];
								distanceLCD[1]=' ';
								distanceLCD[0]=' ';	
							}
		
						if (!isdigit(distanceLCD[2]))
							{	
								distanceLCD[2]=distanceLCD[1];
								distanceLCD[1]= distanceLCD[0];
								distanceLCD[0]=' ';						
							}
					}				
							
				WriteCharLCD (distanceLCD[0]);	//scrivo la distanza sul Display
				WriteCharLCD (distanceLCD[1]);
				WriteCharLCD (distanceLCD[2]);
				
				ShiftCursorLCD (LEFT);		//riposiziono il cursore in modo da aggiornare
				ShiftCursorLCD (LEFT);		//solo le cifre di interesse
				ShiftCursorLCD (LEFT);
				
				if (timeAlarm == 1)	// controllo se attivare la sveglia
				{
					beep ();
					Delay (2);	
				}
				
			}		 				
 	}			
}


//*******************************************************************************************
//Modalit D		Orario Sveglia
//*******************************************************************************************

void modD ()
{	unsigned char alarmTime [6];
	unsigned char data;
		
	AlarmFlag = 0;
	timeAlarm = 0;
	ServoDirection = 0;	//disabilito il rinfresco dei servi
	PORTE = 0;			//Spengo i LED	
	Halt ();	
	
	ClearLCD ();	
	
	while (1)
	{	if (modality != MODD)
			break;
		
		HomeLCD ();
		
		WriteStringLCD ("   Alarm Time");
		Line2LCD ();
		
		data = ReadEEprom (0xA0,0x01,0x00); // leggo l'indirizzo 0100H 	
		alarmTime[1] = (data & 0b00001111)+48; // sommando 48 converto il numero in carattere ASCII
		alarmTime[0] = (data >> 4)+48;
	
		alarmTime[2] = ':';
	
		data = ReadEEprom (0xA0,0x01,0x01); // leggo l'indirizzo 0101H 	
		alarmTime[4] = (data & 0b00001111)+48;
		alarmTime[3] = (data >> 4)+48;	
	
		alarmTime[5] = '\0';
		
		WriteVarLCD (alarmTime);			// scrivo la variabile che contiene l'ora sull'LCD

		data = ReadEEprom (0xA0,0x01,0x02); // leggo l'indirizzo 0101H
		
		if (data == 1)
			WriteStringLCD ("  Alarm ON ");
			else
			WriteStringLCD ("  Alarm OFF");
			
		if (timeAlarm == 1)	// controllo se attivare la sveglia
			{
				beep ();
				Delay (2);	
			}
	}
}

//*******************************************************************************************
//Modalit E		Lamp Service
//*******************************************************************************************

void modE ()
{	int diff;
	unsigned char firstTime;
	unsigned char status;
	int oldDistance = 0;			//distanza precedente
	unsigned char distanceLCD [3]; //la distanza e' una stringa visualizzabile su LCD
	
  	AlarmFlag = 0;
  	timeAlarm = 0;
  	ServoDirection = 0;	//disabilito il rinfresco dei servi
  	PORTE = 0;			//Spengo i LED
  	Halt ();
  			
	ClearLCD ();
	
	WriteStringLCD ("  Lamp Service");
	Line2LCD ();		
	WriteStringLCD ("Distance: --- cm");
		
	
//sposto il cursore all'inizio della cifra piu' significativa della misura	
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);	

	Delay (20);
	if (modality != MODE)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODE)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODE)
			return;
	beep ();	
	Delay (20);
	if (modality != MODE)
			return;
	
	firstTime = 0;
	status = 0;		
    	
	while (1)
	{			
		if (modality != MODE)
			break;
	
		if (Echo == 1)
			{					
				total_us = 0;
				
				while (Echo == 1)
				{	
					total_us++;
					
					_asm
					nop			//il nop rallenta il ciclo di lettura tarando correttamente la lettura
					_endasm										
				}	
				
				distance = total_us >>5;	//divisione per 32
				
				if (distance>MAX_DISTANCE)
					distance = MAX_DISTANCE + 1;
					
				if (!firstTime)
					{
						oldDistance = distance;
						firstTime = 1;
					}
					
		diff = oldDistance-distance;	// controllo se qualcuno si avvicina		
		
		if ( diff > DELTA_DISTANCE)
			{ if (status)
			  		status = 0;
			  		else
			  		status = 1;
			  		
			 	if (status)	
				{ 	if (ReadEEprom (0xA0,0x00,0x50) ==1)	//Controllo se fare il beep
						beep ();
						
					PORTE = 0b00000001;
					Delay (30);
					
					if (timeAlarm)	//controllo se la sveglia  accesa
					{
						timeAlarm=0;	//spengo l'allarme sveglia
						PORTE = 0x00; 	//spengo le luci poich l'accenzione  legato alla sveglia
						
						if (ReadEEprom (0xA0,0x00,0x53) ==1) //controllo se attivare modalit pulizia
							modality = MODB;
					}					
				}
				else
				{ 
					if (ReadEEprom (0xA0,0x00,0x50) ==1)	//Controllo se fare il beep
						beep ();
						
					PORTE = 0b00000000;
					Delay (30);
					
					if (timeAlarm)	//controllo se la sveglia  accesa
					{
						timeAlarm=0;	//spengo l'allarme sveglia
						PORTE = 0x00; 	//spengo le luci poich l'accenzione  legato alla sveglia
						
						if (ReadEEprom (0xA0,0x00,0x53) ==1) //controllo se attivare modalit pulizia
							modality = MODB;
					}				
				}
			}			

// oltre i 4 metri la misura perde di significato e viene visualizzato <->
				
				if (distance> MAX_DISTANCE)	
					{	
						distanceLCD[2]='>';
						distanceLCD[1]='-';
						distanceLCD[0]='<';						
					}
				else 
					{
						itoa (distance,distanceLCD);	// converto la distanza in una stringa	

//sposto le cifre in modo da mantenere lo stesso valore posizionale				
						if (!isdigit(distanceLCD[1]))	
							{
								distanceLCD[2]=distanceLCD[0];
								distanceLCD[1]=' ';
								distanceLCD[0]=' ';	
							}
		
						if (!isdigit(distanceLCD[2]))
							{	
								distanceLCD[2]=distanceLCD[1];
								distanceLCD[1]= distanceLCD[0];
								distanceLCD[0]=' ';						
							}
					}				
							
				WriteCharLCD (distanceLCD[0]);	//scrivo la distanza sul Display
				WriteCharLCD (distanceLCD[1]);
				WriteCharLCD (distanceLCD[2]);
				
				ShiftCursorLCD (LEFT);		//riposiziono il cursore in modo da aggiornare
				ShiftCursorLCD (LEFT);		//solo le cifre di interesse
				ShiftCursorLCD (LEFT);
				
				
				if (timeAlarm == 1)	// controllo se attivare la sveglia
				{
					beep ();
					Delay (2);	
				}
				
			} 				
 	}			
}


//*******************************************************************************************
//Modalit F		Lamp Service a Tempo
//*******************************************************************************************

void modF ()
{	int diff;
	unsigned char firstTime;
	int oldDistance = 0;			//distanza precedente
	unsigned char distanceLCD [3]; //la distanza e' una stringa visualizzabile su LCD
	
	unsigned char startTime[6];	//stringa con l' orario d' attivazione della modalit
	int delta; //variabile che contiene il delta tra orario attivazione e ora corrente
	
  	AlarmFlag = 0;
  	timeAlarm = 0;
  	ServoDirection = 0;	//disabilito il rinfresco dei servi
  	PORTE = 0;			//Spengo i LED
  	Halt ();
  			
	ClearLCD ();
	
	WriteStringLCD ("Lamp Service Bis");
	Line2LCD ();		
	WriteStringLCD ("Distance: --- cm");
		
	
//sposto il cursore all'inizio della cifra piu' significativa della misura	
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);
	ShiftCursorLCD (LEFT);	

	Delay (20);
	if (modality != MODF)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODF)
			return;
	beep ();	
	Delay (20);	
	if (modality != MODF)
			return;
	beep ();	
	Delay (20);
	if (modality != MODF)
			return;
			
	firstTime = 0;
    	
	while (1)
	{			
		if (modality != MODF)
			break;
	
		if (Echo == 1)
			{					
				total_us = 0;
				
				while (Echo == 1)
				{	
					total_us++;
					
					_asm
					nop			//il nop rallenta il ciclo di lettura tarando correttamente la lettura
					_endasm										
				}	
				
				distance = total_us >>5;	//divisione per 32
				
				if (distance>MAX_DISTANCE)
					distance = MAX_DISTANCE + 1;
					
				if (!firstTime)
					{
						oldDistance = distance;
						firstTime = 1;
					}
					
		diff = oldDistance-distance;	// controllo se qualcuno si avvicina		
		
		if ( diff > DELTA_DISTANCE)		// l'accenzione monostabile retriggerabile
			{ 
			 		if (ReadEEprom (0xA0,0x00,0x50) ==1)	//Controllo se fare il beep
						beep ();
						
					PORTE = 0b00000001;	// accendo le luci
					
					copyStr (startTime,ReadTime());	//memorizzo l'orario di attivazione delle luci
					
					if (timeAlarm)	//controllo se la sveglia  accesa
					{
						timeAlarm=0;	//spengo l'allarme sveglia
						PORTE = 0x00; 	//spengo le luci poich l'accenzione  legato alla sveglia
						
						if (ReadEEprom (0xA0,0x00,0x53) ==1) //controllo se attivare modalit pulizia
							modality = MODB;
					}						
			}				

//controllo che sia passato il tempo per cui deve essere accesa la lampada
			
			delta = deltaTime (startTime,ReadTime());
			
			if (delta == ReadEEprom (0xA0,0x00,0x77) || delta <0 ) //prelevo il tempo di pulizia dalla EEPROM
				PORTE = 0x00;	// spengo le luci


// oltre i 4 metri la misura perde di significato e viene visualizzato <->
				
				if (distance> MAX_DISTANCE)	
					{	
						distanceLCD[2]='>';
						distanceLCD[1]='-';
						distanceLCD[0]='<';						
					}
				else 
					{
						itoa (distance,distanceLCD);	// converto la distanza in una stringa	

//sposto le cifre in modo da mantenere lo stesso valore posizionale				
						if (!isdigit(distanceLCD[1]))	
							{
								distanceLCD[2]=distanceLCD[0];
								distanceLCD[1]=' ';
								distanceLCD[0]=' ';	
							}
		
						if (!isdigit(distanceLCD[2]))
							{	
								distanceLCD[2]=distanceLCD[1];
								distanceLCD[1]= distanceLCD[0];
								distanceLCD[0]=' ';						
							}
					}				
							
				WriteCharLCD (distanceLCD[0]);	//scrivo la distanza sul Display
				WriteCharLCD (distanceLCD[1]);
				WriteCharLCD (distanceLCD[2]);
				
				ShiftCursorLCD (LEFT);		//riposiziono il cursore in modo da aggiornare
				ShiftCursorLCD (LEFT);		//solo le cifre di interesse
				ShiftCursorLCD (LEFT);
				
				
				if (timeAlarm == 1)	// controllo se attivare la sveglia
				{
					beep ();
					Delay (2);	
				}
				
			} 				
 	}			
}


//*******************************************************************************************
//Modalit G		Controllo Remoto
//*******************************************************************************************

void modG ()
{		
	AlarmFlag = 0;
	timeAlarm = 0;
	ServoDirection = 0;	//disabilito il rinfresco dei servi
	PORTE = 0;			//Spengo i LED	
	Halt ();	
	
	beep ();
	Delay (20);
	
	ClearLCD ();	
	
	HomeLCD ();
		
	WriteStringLCD (" Remote Control");
	Line2LCD ();
	
	while (1)
	{	if (modality != MODG)
			break;
						
		//effettuo la lettura distanza
		if (Echo == 1)
			{					
				total_us = 0;
				
				while (Echo == 1)
				{	
					total_us++;
					
					_asm
					nop			//il nop rallenta il ciclo di lettura tarando correttamente la lettura
					_endasm										
				}	
				
				RemoteDistance = total_us >>5;	//divisione per 32		
			
			}
	}
}
