 
 
//*******************************************************************************************
// Costanti non modificabili
//*******************************************************************************************

#define PIEZO PORTEbits.RE1

#define Trig PORTCbits.RC0		
#define Echo PORTCbits.RC5

#define SERVO PORTDbits.RD0

#define RED_BUTTON PORTBbits.RB7	//tasto mdalit
#define LEFT_BUTTON PORTBbits.RB4	//pulsante urti a sinistra
#define RIGHT_BUTTON PORTBbits.RB5	//pulsante urti a destra


//*******************************************************************************************
// Costanti modificabili (ricompilazione richiesta)
//*******************************************************************************************

#define NUM_MOD 7	//costanti associate alle modalit

#define MODA 1	
#define MODB 2
#define MODC 3
#define MODD 7
#define MODE 4
#define MODF 5
#define MODG 6


//*******************************************************************************************
// Costanti modificabili aggiornando la EEPROM
//*******************************************************************************************

int MAX_DISTANCE; 	//specifica distanza massima per il sensore SRF5 (add 0x0053)
int NIGHT_LEVEL ;		// livello con cui riconosco la notte (add 0x0054)
unsigned char DELTA_DISTANCE ;	//variazione di distanza che fa attivare l'allarme (add 0x0055)
unsigned char LIGHT_FILTER;		// livello di isteresi (add 0x0056)
unsigned char NUM_BLOCK;			// numero di volte in cui si ha la distanza uguale (add 0x0057)
unsigned char DELTA_BLOCK;		// variazione distanza per predizione stallo (add 0x0058) 
 

//*******************************************************************************************
// Variabili di sistema non modificabili 
//*******************************************************************************************

unsigned char Period = 249; 		//PWM imposto una frequenza di 20KHz

unsigned char modality = 1;			// numero modalit in esecuzione 

unsigned char data [7];				// variabile che conterr i dati ricevuti 

unsigned char ServoDirection = 0;	//determina la posizione del Servo 0,1,2,3

int total_us ;						// variabile globali per la misura dello spazio in us

unsigned char initDone = 0; // Se il flag vale 1 il test periferiche non viene rieseguito al comando X0000000



//*******************************************************************************************
// Variabili di sistema utilizzabili 
//*******************************************************************************************

unsigned char *Time;	// orario di sistema senza secondi
unsigned char *Date;	// data di sistema

int speedTable[6];		//tabella delle velocit 


int distance = 0;		// variabile che contiene la distanza come valore intero in cm
int distanceLeft = 0;	//distanza oggetto a sinistra
int distanceRight = 0;	//distanza oggetto a destra
int RemoteDistance = 0; // valore della lettura della distanza da remoto

unsigned char AlarmFlag = 0;	// 1 segnala allarme estraneo MODC
unsigned char timeAlarm = 0;	// 1 segnala se ho un allarme sveglia  
unsigned char Night = 0;		// 1 segnala che e' notte 0 che e' giorno
int temperature = 0; 			// Temperatura ambiente 
int batteryLevel = 0;			// Livello batteria in pecentuale


unsigned char LeftCrash =0;			// Flag che segnale un urto a sinistra
unsigned char RightCrash =0; 		// Flag che segnale un urto a detra
unsigned char LeftRoadBlock = 0;	// Flag che segnala che il robot e' incastrato a sinistra
unsigned char RightRoadBlock = 0;	// Flag che segnala che il robot e' incastrato a destra
unsigned char FrontRoadBlock = 0;	// Flag che segnala che il robot e' incastrato a davanti

unsigned char leftCounter = 0;		// contatori per verificare da quanto le distanze non variano
unsigned char rightCounter = 0;
unsigned char frontCounter = 0;
